#!/usr/bin/perl
#
# cdeditimage.perl
#
# this program draws the forms for selecting the album cover art.
#

########################################################################
# perl script boilerplate.
# set tunebot root and load utility module.
#
BEGIN {
    $tunebot_root="XXX-the-tunebot-install-root";
    @INC=($tunebot_root."/lib", @INC);
}
use Tunebot;
#
# end of perl boilerplate
########################################################################

$cgibinurl=$configs{"CGI_BIN_URL"};
$topurl=$configs{"HTML_TOP_URL"};

$debug=0;
$ses_directory=$tunebot_root."/data/loader";
$uprefs_directory=$tunebot_root."/data/userprefs";

#
# add/replace a tag value into the current session.
# assumes $ses_directory, $usrnam and $sesno are set.
# creates the session if it doesn't already exist.
#
sub addSesTag {
    open (O, ">>$ses_directory/$usrnam.$sesno");
    print O @_, "\n";
    close(O);
    chmod 0666, "$ses_directory/$usrnam.$sesno";
}

#
# lookup a tag value from the current session.
# assumes $ses_directory, $usrnam and $sesno are set.
# returns the tag value, or "" if not defined.
#
sub getSesTag {
    my ($tag) = $_[0] . "=";
    my ($l) = length($tag);
    my $val;
    my $i;
    open (I, "$ses_directory/$usrnam.$sesno");
    while ($i = <I>) {
	chomp $i;
	if (substr($i, 0, $l) eq $tag) {
	    $val = $i;
	    $val =~ s/^[^=]*=//;
	}
    }
    close(I);
    return $val;
}

#
# lookup the entire history of a tag value from the current session.
# assumes $ses_directory, $usrnam and $sesno are set.
# returns an array of values, in order found.
#
sub getSesTagAll {
    my ($tag) = $_[0] . "=";
    my ($l) = length($tag);
    my $val;
    my @lst;
    my $i;
    open (I, "$ses_directory/$usrnam.$sesno");
    while ($i = <I>) {
	chomp $i;
	if (substr($i, 0, $l) eq $tag) {
	    $val = $i;
	    $val =~ s/^[^=]*=//;
	    @lst = (@lst, $val);
	}
    }
    close(I);
    return @lst;
}

#
# reinitialize the session edit buffer.
#
sub initSesEditTag {
    open (O, ">$ses_directory/$usrnam.$sesno"."_e");
    close(O);
    chmod 0666, "$ses_directory/$usrnam.$sesno"."_e";
}

#
# add/replace a tag value into the current session edit buffer.
# assumes $ses_directory, $usrnam and $sesno are set.
# creates the session if it doesn't already exist.
#
sub addSesEditTag {
    open (O, ">>$ses_directory/$usrnam.$sesno"."_e");
    print O @_, "\n";
    close(O);
    chmod 0666, "$ses_directory/$usrnam.$sesno"."_e";
}

#
# lookup a tag value from the current session edit buffer.
# assumes $ses_directory, $usrnam and $sesno are set.
# returns the tag value, or "" if not defined.
#
sub getSesEditTag {
    my ($tag) = $_[0] . "=";
    my ($l) = length($tag);
    my $val;
    my $i;
    open (I, "$ses_directory/$usrnam.$sesno"."_e");
    while ($i = <I>) {
	chomp $i;
	if (substr($i, 0, $l) eq $tag) {
	    $val = $i;
	    $val =~ s/^[^=]*=//;
	}
    }
    close(I);
    return $val;
}

#
# add/replace a tag value into the user preferences
# assumes $uprefs_directory and $usrnam are set.
# creates the preferences file if it doesn't already exist.
#
sub addUPrefsTag {
    open (O, ">>$uprefs_directory/$usrnam");
    print O @_, "\n";
    close(O);
    chmod 0666, "$uprefs_directory/$usrnam";
}

#
# lookup a tag value from the user preferences.
# assumes $uprefs_directory and $usrnam are set.
# returns the tag value, or "" if not defined.
#
sub getUPrefsTag {
    my ($tag) = $_[0] . "=";
    my ($l) = length($tag);
    my ($val) = $_[1];
    my $i;
    open (I, "$uprefs_directory/$usrnam");
    while ($i = <I>) {
	chomp $i;
	if (substr($i, 0, $l) eq $tag) {
	    $val = $i;
	    $val =~ s/^[^=]*=//;
	}
    }
    close(I);
    return $val;
}

Tunebot::suckInCookies;
$tunebot_user=$cookie{TUNEBOTUSER};
Tunebot::suckInPostGet;

Tunebot::suckInTags();
Tunebot::suckInAutotags();

#
# security hole - we trust these as filenames and stuff.
#
$usrnam=$tunebot_user;
$usrnam =~ tr/[A-Za-z0-9]//dc;
$sesno=$posts{"sesno"};
$sesno =~ tr/[0-9]//dc;

Tunebot::printPageHeader "Album Cover";

if ($posts{imageurl} ne "") {
#    print "WOULD HAVE FETCHED IMAGE into $ses_directory/$usrnam.$sesno\_ai\n";
#    print "<p>\n";

    system("$tunebot_root/bin/httpget -o $ses_directory/$usrnam.$sesno\_ai $posts{imageurl}");
    addSesTag("AIFILE=$usrnam.$sesno\_ai");
}

if ($posts{removeimage} == 1) {
    addSesTag("AIFILE=");
}

if ($posts{resize170} == 1) {
    open(I, "/usr/bin/file $ses_directory/$usrnam.$sesno\_ai |");
    $t="";
    while (<I>) {
	if (/JPEG/) { $t="j"; }
	if (/GIF/) { $t="g"; }
    }
    close(I);
    if ($t eq "j") {
	system("/bin/cat $ses_directory/$usrnam.$sesno\_ai | /usr/bin/djpeg | pnmscale -width 170 | /usr/bin/cjpeg -quality 95 > /tmp/cdeditimage.$$");
	system("/bin/cat /tmp/cdeditimage.$$ > $ses_directory/$usrnam.$sesno\_ai");
	system("/bin/rm /tmp/cdeditimage.$$");
    }
    if ($t eq "g") {
	system("/usr/bin/giftopnm $ses_directory/$usrnam.$sesno\_ai | pnmscale -width 170 | /usr/bin/cjpeg -quality 95 > /tmp/cdeditimage.$$");
	system("/bin/cat /tmp/cdeditimage.$$ > $ses_directory/$usrnam.$sesno\_ai");
	system("/bin/rm /tmp/cdeditimage.$$");
    }
}

$aifile = getSesTag("AIFILE");
if ($aifile ne "") {
    print "<img src=\"$cgibinurl/cdloadimage.cgi?sesno=$sesno\"></a>\n";
} else {
    print "No cover\n";
}

print "<p>\n";
print "<form action=\"$cgibinurl/cdeditimage.cgi\">";
print "<input type=hidden name=sesno value=\"$sesno\">\n";
print "Enter URL to fetch image: ";
print "<input name=imageurl type=text>\n";
print "</td></tr></table>";
print "</form>\n";

print "<p>\n";
print "<a href=\"$cgibinurl/cdeditimage.cgi?sesno=$sesno&removeimage=1\">Remove image</a>\n";

print "<p>\n";
print "<a href=\"$cgibinurl/cdeditimage.cgi?sesno=$sesno&resize170=1\">Resize image</a> to standard 170x170\n";

print "<p>\n";
print "<a href=\"$cgibinurl/cdload.cgi?sesno=$sesno\">Go back</a> to session\n";

#
# this is for debugging.
# it lists all the session tags at the end of the form.
#
if (getSesTag("SESSIONDEBUG") == 1) {
    print "<p>\n";
    print "<center>*</center>\n";
    print "<hr>\n";
    print "<p>\n";
    print "<center>Session Tags</center>\n";
    print "<font color=white>\n";
    print "<ul><pre>\n";
    open(I, "$ses_directory/$usrnam.$sesno");
    while (<I>) {
	print;
    }
    close(I);
    print "</pre></ul>\n";
    print "</font>\n";
    print "<hr>\n";
    print "<font size=-1><em>Disable</em> <a href=\"$cgibinurl/cdeditimage.cgi?sesno=$sesno&debugses=0\">Session Debugging</a></font>\n";
} else {
    if ($sesno ne "") {
	print "<p>\n";
	print "<font size=-1><em>Enable</em> <a href=\"$cgibinurl/cdeditimage.cgi?sesno=$sesno&debugses=1\">Session Debugging</a></font>\n";
    }
}

Tunebot::printPageTrailer;
exit 0

