#!/usr/bin/perl
#
# playalbum.cgi
#
# play album with some options
#
# imports:
#  settings:
#    TUNEBOT_ROOT    root of tunebot installation.
#    TUNEIX          index of tune files.
#    TUNETAGS        index of tune attributes.
#    BANNER_STRING   identifying string for web page titles
#  environment:
#    QUERY_STRING    string from the browser
#  files:
#    $TUNEBOT_ROOT/tune.autotags
#

########################################################################
# perl script boilerplate.
# set tunebot root and load utility module.
#
BEGIN {
    $tunebot_root="XXX-the-tunebot-install-root";
    @INC=($tunebot_root."/lib", @INC);
}
use Tunebot;
#
# end of perl boilerplate
########################################################################

sub renderAlbum {
    my $albnum=$_[0];
    my $trknum=$autotags{$autotags{"IXA/AB/$albnum", "PATH"}, "IXA_FTA"};

    $path=$autotags{"IXA/TK/$trknum", "PATH"};
    @raw = split('/', $path);
    $n = $#raw;
    $artistpath = join("/", @raw[0..$n-2]);
    $artistname = $tags{$artistpath, "N"};
    if ($artistname eq "") {
	$artistname = $raw[$n-2];
    }
    $sartist = $tags{$artistpath, "SORT"};
    if ($sartist eq "") {
	$sartist = $artistname;
	$sartist =~ tr/a-z/A-Z/;
    }
    $albumpath = join("/", @raw[0..$n-1]);
    $albumname = $tags{$albumpath, "N"};
    if ($albumname eq "") {
	$albumname = $raw[$n-1];
    }

    $faa = $autotags{$artistpath, "IXA_FAA"};
    print "<p><font size=+2><a href=\"$cgibinurl/dynindex.cgi?abn=$faa\">$artistname</a></font>\n";

    print "<ul>\n";
    print "<li><b> $albumname </b>\n";
    if ($tags{$albumpath, "DATE"} ne "") {
	print "<br><em>" . $tags{$albumpath, "DATE"} . "</em>\n";
    }

    if ($tags{$albumpath, "ICON"} ne "") {
	$albumicon=$albumpath . "/" . $tags{$albumpath, "ICON"};
	$albumicon =~ s/^\///;
	$albumicon =~ s/\//./g;
	$albumicon="$topurl/icons/". $albumicon;
    } else {
	$albumicon="";
    }
    print "<table width=90% cellpadding=0>\n";
    print "<tr><td width=60%>\n";
    print "<table width=100% cellpadding=0>\n";
    $t=1;
    ALBUM: while (($path=$autotags{"IXA/TK/$trknum", "PATH"}) ne "") {
	@raw = split('/', $path);
	$n = $#raw;
	$ap = join("/", @raw[0..$n-1]);
	if ($ap ne $albumpath) {
	    last ALBUM;
	}
	$track = $tags{$path, "N"};
	if ($track eq "") {
	    $track = $raw[$n];
	}
	if ($tags{$path, "ARTIST"} ne "") {
	    $track = $track."<em> - ".$tags{$path, "ARTIST"}."</em>";
	}
	$picktrack{$t}=1-$picktrack{$t};
	$tlist="";
	foreach $tt (sort keys %picktrack) {
	    if ($picktrack{$tt}) {
		$tlist .= "&t$tt=1";
	    }
	}
	$picktrack{$t}=1-$picktrack{$t};
	print "<tr>";
	print "<td align=right><font size=-1>$t.</font> <a href=\"$cgibinurl/playalbum.cgi?album=$album$tlist\">$track</a></td>";
	print "<td width=25% align=left>\n";
	if ($picktrack{$t}) {
	    print "<img src=\"$topurl/note.gif\">\n";
	}
	print "</td>\n";
	print "</tr>\n";

	$t++;
	++$trknum;
    }
    $albumtracks=$t-1;
    print "</table></td><td align=center>\n";
    if ($albumicon ne "") {
	print "<img src=\"$albumicon\">\n"
    }
    print "</td></tr></table>\n";
    print "</ul>\n";
}


$debug=0;

$cgibinurl=$configs{"CGI_BIN_URL"};
$topurl=$configs{"HTML_TOP_URL"};
Tunebot::suckInCookies;
$tunebot_user=$cookie{TUNEBOTUSER};
Tunebot::suckInPostGet;

#
# if we're been told to commit, grind out a forwarding header to
# send the selection to tuneput.
#
if ($posts{"commit"} ne "") {
#    $album=Tunebot::urldecode($posts{"album"}).":";
    $album=$posts{"album"}.":";
    foreach $i (%posts) {
	if ($i =~ /^t[0-9]/) {
	    $i =~ s/^t//;
	    $album.="$i,";
	}
    }
    print "Content-type: text/html\n";
    print "\n";
    print "<html>\n";
    print "<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
    print "<META HTTP-EQUIV=REFRESH CONTENT=\"0; URL=tuneput.cgi?album=" . $album . "\">";
    print "</html>\n";

} else {
#
# otherwise, we're still choosing tracks.  re-render the selection form.
#
    Tunebot::suckInTags;
    Tunebot::suckInAutotags;

    Tunebot::printPageHeader "Play Album Tracks";
    print "<p>\n";
    print "<center><font size=+2><b>Pick Tracks to Play</b></font></center>\n";
    print "<p>\n";

    $album=$posts{"album"};
    foreach $i (%posts) {
	if ($i =~ /^t[0-9]/) {
	    $i =~ s/^t//;
	    $picktrack{$i}=1;
	}
    }
    if ($album ne "") {
	renderAlbum $autotags{$album, "IXA_ABN"};

	print "<p><center>\n";
	print "<a href=\"$cgibinurl/playalbum.cgi?album=$album\"> <font size=+1><b>Start Over</b></font> </a>\n";

	print " <img align=center src=\"$topurl/burst.gif\"> ";
	$tlist="";
	for ($tt=1; $tt<=$albumtracks; ++$tt) {
	    $tlist .= "&t$tt=1";
	}
	print "<a href=\"$cgibinurl/playalbum.cgi?album=$album$tlist\"> <font size=+1><b>Everything</b></font> </a>\n";

	print " <img align=center src=\"$topurl/burst.gif\"> ";
	$tlist="";
	foreach $tt (sort keys %picktrack) {
	    if (!$picktrack{$tt}) {
		$tlist .= "&t$tt=1";
	    }
	}
	print "<a href=\"$cgibinurl/playalbum.cgi?album=$album$tlist\"> <font size=+1><b>Not</b></font> </a>\n";

	print " <img align=center src=\"$topurl/burst.gif\"> ";
	$tlist="&commit=1";
	foreach $tt (sort keys %picktrack) {
	    if ($picktrack{$tt}) {
		$tlist .= "&t$tt=1";
	    }
	}
	print "<a href=\"$cgibinurl/playalbum.cgi?album=$album$tlist\"> <font size=+1><b>Ok, do it</b></font> </a>\n";
	print "</center>\n";
    }
    Tunebot::printPageTrailer;
}

exit 0
