#!/usr/bin/perl
#
# ttserv.cgi
#
# 2002-12-6 manchek
#
# tunebot-tunebot http synchronization server
#

########################################################################
# perl script boilerplate.
# set tunebot root and load utility module.
#
BEGIN {
    $tunebot_root="XXX-the-tunebot-install-root";
    @INC=($tunebot_root."/lib", @INC);
}
use Tunebot;
#
# end of perl boilerplate
########################################################################

$cgibinurl=$configs{"CGI_BIN_URL"};
$topurl=$configs{"HTML_TOP_URL"};

Tunebot::suckInPostGet;

Tunebot::suckInTags();
Tunebot::suckInAutotags();

if ($posts{listalbums} ne "") {
    print "Content-type: text/plain\n";
    print "\n";
    $nal=$autotags{"IXA", "NAB"};
    print "#Albums 1-$nal\n";
    for ($an=1; $an<= $nal; ++$an) {
	$ap=$autotags{"IXA/AB/$an", "PATH"};
	print "$an $ap\n";
    }

} elsif ($posts{album} ne "") {
    print "Content-type: text/plain\n";
    print "\n";
    $ap=$posts{album};
    $an=$autotags{$ap, "IXA_ABN"};
    if ($an > 0) {
	print "#Path $ap\n";
	print "#Album number $an\n";
	$atl=$autotags{$ap, "TAGS"};
	print "#Album tags are: $atl\n";
	foreach $at (split / /, $atl) {
	    print "$at=$tags{$ap,$at}\n";
	}
	$tn=$autotags{$ap, "IXA_FTA"};
	$tc=$autotags{$ap, "IXA_NTA"};
	print "#Start track $tn for $tc\n";
	if ($tc > 100) {
	    $tc = 100;
	}
	while ($tc > 0) {
	    $tp=$autotags{"IXA/TK/$tn", "PATH"};
	    print "track=$tp\n";
	    ++$tn;
	    --$tc;
	}
    } else {
	print "Album $ap not found\n";
    }

} elsif ($posts{artist} ne "") {
    print "Content-type: text/plain\n";
    print "\n";
    $ap=$posts{artist};
    print "#Path $ap\n";
    $atl=$autotags{$ap, "TAGS"};
    print "#Artist tags are: $atl\n";
    foreach $at (split / /, $atl) {
	print "$at=$tags{$ap,$at}\n";
    }

} elsif ($posts{track} ne "") {
    print "Content-type: text/plain\n";
    print "\n";
    $tp=$posts{track};
    $tn=$autotags{$tp, "IXA_TKN"};
    if ($tn > 0) {
	print "#Path $tp\n";
	print "#Track number $tn\n";
	print "data=$tp.mp3\n";
	$ttl=$autotags{$tp, "TAGS"};
	print "#Track tags are: $ttl\n";
	foreach $tt (split / /, $ttl) {
	    print "$tt=$tags{$tp,$tt}\n";
	}
    } else {
	print "Track $tp not found\n";
    }

} elsif ($posts{data} ne "") {
    $fp=$posts{data};
#
# we should validate and clean up the path
# make sure it's below one of the directories in $configs{MUSIC}
# make sure it doesn't have any dotdots.
#
    if (-f $fp && -r $fp) {
	$ft="";
	if ($fp =~ /\.jpg$/) { $ft="image/jpeg"; }
	if ($fp =~ /\.jpeg$/) { $ft="image/jpeg"; }
	if ($fp =~ /\.JPG$/) { $ft="image/jpeg"; }
	if ($fp =~ /\.JPEG$/) { $ft="image/jpeg"; }
	if ($fp =~ /\.gif$/) { $ft="image/gif"; }
	if ($fp =~ /\.GIF$/) { $ft="image/gif"; }
	if ($fp =~ /\.mp3$/) { $ft="audio/mpeg"; }

	if ($ft eq "") {
	    print "Content-type: text/plain\n";
	    print "\n";
	    print "Unknown filetype for $fp\n";

	} else {
	    @a=stat($fp);
	    $fl=$a[7];
	    print "Content-type: $ft\n";
	    print "Content-length: $fl\n";
	    print "\n";
	    open(I, $fp);
	    binmode I;
	    while (read(I, $x, 1024) > 0) {
		print $x;
	    }
	    close(I);
	}

    } else {
	print "Content-type: text/plain\n";
	print "\n";
	print "Access denied for $fp\n";
    }

} else {
    print "Content-type: text/plain\n";
    print "\n";
    print "# Tunebot ttserver software version $configs{TUNEBOT_VERSION}\n";
    print "# Commands are:\n";
    print "#   listalbums=1          list all album directory paths\n";
    print "#   album={album_path}    tags and track file paths for album\n";
    print "#   artist={artist_path}  tags for artist directory\n";
    print "#   track={track_path}    tags for track\n";
    print "#   data={file_path}      retrieve file data\n";
}

exit 0;

