#!/usr/bin/perl
#
# tuneq.cgi
#
# list the tune currently playing, ones recently played, and ones in the q.
#
# imports:
#  settings:
#    TUNEBOT_ROOT    root of tunebot installation.
#    QDIR            directory where requests and play history live.
#    BANNER_STRING   identifying string for web page titles
#  controls:
#    HOWMANY_TUNES   how many tunes of history to show
#
#  files:
#    $TUNEBOT_ROOT/tune.autotags
#

########################################################################
# perl script boilerplate.
# set tunebot root and load utility module.
#
BEGIN {
    $tunebot_root="XXX-the-tunebot-install-root";
    @INC=($tunebot_root."/lib", @INC);
}
use Tunebot;
#
# end of perl boilerplate
########################################################################

$cgibinurl=$configs{"CGI_BIN_URL"};
$topurl=$configs{"HTML_TOP_URL"};

$q_directory=$configs{"QDIR"};
$how_many=$configs{"HOWMANY_TUNES"};
if ($how_many < 1) {
    $how_many=10;
}
$q=$ENV{"QUERY_STRING"};
if ($configs{"PLAY_CONTROLS"} != 0
&& ($q eq "restart" || $q eq "kill" || $q eq "pause" || $q eq "resume")) {
    $t = 0;
    $t = 2 if ($q eq "kill");
    open(O, ">/tmp/jobctl");
    print O "$q\n";
    close(O);
    if ($q eq "pause" || $q eq "resume") {
	Tunebot::rewriteTagInFile("$q_directory/nowplaying", "CTRL", $q);
    }
    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<head>\n";
    print "<META HTTP-EQUIV=REFRESH CONTENT=\"$t; URL=$cgibinurl/tuneq.cgi\">\n";
    print "</head>\n";
    print "</html>\n";
    exit 0;
}
if ($q =~ /^[0-9]/) {
    $how_many = $q;
}
$random_from_q=$configs{"RANDOM_FROM_Q"};
if ($random_from_q > 0) {
    $random_from_q = 1;
} else {
    $random_from_q = 0;
}

Tunebot::suckInTags;
Tunebot::suckInAutotags;
Tunebot::suckInCookies;
$tunebot_user=$cookie{TUNEBOTUSER};

sub nicetime {
    my ($a) = @_[0];
    my ($m1) = substr($a, 14, 2);
    my ($h1) = substr($a, 11, 2);
    my ($d1) = substr($a, 8, 2);
    my ($n1) = substr($a, 5, 2);
    my ($y1) = substr($a, 0, 4);
    my ($i, $m0, $h0, $d0, $n0, $y0, $i, $i, $i) = localtime(time);
    $n0++;
    $y0 += 1900;
    $i = "";
    if ($y1 != $y0) {
	$i = $y1 . "/";
	$n0 = -1;
    }
    if ($n1 != $n0 || $d1 != $d0) {
	$i = $i . $n1 . "/" . $d1 . " ";
	$d0 = -1;
    }
    my ($ap) = "am";
    if ($h1 > 11) {
	$h1 -= 12;
	$ap = "pm";
    }
    if ($h1 == 0) {
	$h1 = 12;
    }
    $i = "$i$h1:$m1 $ap";
    return $i;
}

sub gettime {
    my ($i) = Tunebot::lookupTagInFile(@_, "T=");
    if ($i eq "") {
	$i = "?";
    }
    $i = "(" . $i . ")";
    return $i;
}

$mydomain=`/bin/hostname`;
chop $mydomain;
$mydomain =~ s/^[^.]*.//;

if ($configs{"RELOAD_WHUZZON"} > 0) {
    Tunebot::printPageHeaderNoWhuzzon "Whuzzon", "", "<meta http-equiv=\"refresh\" CONTENT=\"".$configs{"RELOAD_WHUZZON"}."\">\n";
} else {
    Tunebot::printPageHeaderNoWhuzzon "Whuzzon";
}

print "<table width=90% align=center cellpadding=0 cellspacing=0>\n";
print "<tr><td colspan=3 align=center><font size=+1><b>Now Playing</b></font></td></tr>\n";
$status = Tunebot::lookupTagInFile($q_directory . "/nowplaying", "STATUS=");
if ($status ne "") {
    print "<tr><td></td><td><b> $status </b></td></tr>\n";
}
$path = Tunebot::lookupTagInFile($q_directory . "/nowplaying", "Q=");
if ($path ne "") {
    $req = Tunebot::lookupTagInFile($q_directory . "/nowplaying", "SRC=");
    if ($req eq "REQ") {
	$req = " <img src=\"$topurl/request.gif\">";
	$host = Tunebot::lookupTagInFile($q_directory . "/nowplaying", "HOSTNAME=");
	if (!($host =~ /^[0-9]/)) {
	    $hdomain = $host;
	    $hdomain =~ s/^[^.]*.//;
	    if ($hdomain eq $mydomain) {
		$host =~ s/\..*//;
	    }
	}
    } else {
	$req = "";
	$host = "";
    }
    @a = stat $q_directory . "/nowplaying";
    $elaps = time() - $a[9];
    $elaps = sprintf "%d:%02d", $elaps / 60, $elaps % 60;
    $title = Tunebot::friendlyTrackTitle($path);
    $time = gettime($path);
    print "<tr>\n";
    print "<td width=10%><a href=$cgibinurl/tunefeedback.cgi?UP=$path><img src=$topurl/thumbsup.gif border=0 alt=\"Thumbs-Up\"></a>\n";
    print "<a href=$cgibinurl/tunefeedback.cgi?DOWN=$path><img src=$topurl/thumbsdown.gif border=0 alt=\"Thumbs-Down\"></a>\n";
    if ($configs{"PLAY_CONTROLS"} != 0) {
	print "<br><a href=$cgibinurl/tuneq.cgi?restart><img src=$topurl/stepback.gif border=0 alt=\"Replay\"></a>\n";
	if (Tunebot::lookupTagInFile("$q_directory/nowplaying", "CTRL")
	eq "pause") {
	    print "<a href=$cgibinurl/tuneq.cgi?resume><img src=$topurl/play.gif border=0 alt=\"Play\"></a>\n";
	} else {
	    print "<a href=$cgibinurl/tuneq.cgi?pause><img src=$topurl/pause.gif border=0 alt=\"Pause\"></a>\n";
	}
	print "<a href=$cgibinurl/tuneq.cgi?kill><img src=$topurl/stepfwd.gif border=0 alt=\"Skip\"></a>\n";
    }
    print "<br>+ $elaps</td>\n";
    print "<td width=60%>$title</td>\n";
    print "<td><a href=\"$cgibinurl/abouttrack.cgi?$path\">$time</a>$req $host</td>\n";
    print "</tr>\n";
    $albumicon="";
    if ($configs{"NOW_PLAYING_COVER"}) {
	($a=$path) =~ s/\/[^\/]*$//;
	if ($tags{$a, "ICON"} ne "") {
	    $albumicon=$a . "/" . $tags{$a, "ICON"};
	    $albumicon =~ s/^\///;
	    $albumicon =~ s/\//./g;
	    $albumicon="$topurl/icons/". $albumicon;
	}
    }
    if ($albumicon ne "") {
	$u=Tunebot::albumIndexUrl($path);
	print "<tr><td colspan=3 align=center cellpadding=0 cellspacing=0><a href=\"$u\"><img border=0 height=128 align=center src=\"$albumicon\"></a></td></tr>\n";
    }
}

sub numeric { $a <=> $b; }

opendir(D, $q_directory);
@qfs = ();
foreach $i (sort numeric readdir(D)) {
    if ($i =~ /^[0-9]/) {
	@qfs = (@qfs, $i);
    }
}
closedir(D);
if ($#qfs >= 0) {
    print "<tr><td colspan=3 align=center><font size=+1><b>Requests <img src=\"$topurl/request.gif\"></b></font></td></tr>\n";

} else {
    $path = Tunebot::lookupTagInFile($q_directory . "/upnext", "Q=");
    if ($path ne "") {
	print "<tr><td colspan=3 align=center><font size=+1><b>Up Next</b></font></td></tr>\n";
	$req = "";
	$host = "";
	$title = Tunebot::friendlyTrackTitle($path, 1);
	$time = gettime($path);
	print "<tr><td width=10%>";
	print "<a href=$cgibinurl/tunewhack.cgi?upnext><img src=$topurl/skull.gif border=0 alt=\"Whack\"></a></td>\n";
	print "<td width=60%>$title</td>\n";
	print "<td><a href=\"$cgibinurl/abouttrack.cgi?$path\">$time</a></td>\n";
	print "</tr>\n";
    }
}
$n = 1;
foreach $i (@qfs) {
    if ($i =~ /^[0-9]/) {
	$type = Tunebot::lookupTagInFile($q_directory . "/" . $i, "TYPE=");
	$path = Tunebot::lookupTagInFile($q_directory . "/" . $i, "Q=");
	$host = Tunebot::lookupTagInFile($q_directory . "/" . $i, "HOSTNAME=");
	$at = Tunebot::lookupTagInFile($q_directory . "/" . $i, "AT=");
	$dedic = Tunebot::lookupTagInFile($q_directory . "/" . $i, "DEDICATION=");
	if ($dedic ne "") {
	    $dedic = "<br><font color=gold>" . $dedic . "</font>";
	}
	if (!($host =~ /^[0-9]/)) {
	    $hdomain = $host;
	    $hdomain =~ s/^[^.]*.//;
	    if ($hdomain eq $mydomain) {
		$host =~ s/\..*//;
	    }
	}
	if ($host ne "") {
	    $host = "<a href=\"$cgibinurl/tuneded.cgi?" . $i . "\">" . $host . "</a>";
	}
	if ($at ne "") {
	    $reqtime = substr($at,0,4) . "/" . substr($at,4,2) . "/" . substr($at,6,2) . " " . substr($at,8,2) . ":" . substr($at,10,2);
	    $reqtime = "<em>~ " . nicetime($reqtime) . "</em>";
	} else {
	    $reqtime = "";
	}
	if ($type eq "ALBUM") {
	    $title = Tunebot::friendlyAlbumTitle($path);
	    $time = Tunebot::lookupTagInFile($q_directory . "/" . $i, "T=");
	    $trk = Tunebot::lookupTagInFile($q_directory . "/" . $i, "CTRACK=");
	    $trks = Tunebot::lookupTagInFile($q_directory . "/" . $i, "TRACKS=");
	    print "<tr><td width=10%>\n";
	    if ($random_from_q == 0) {
		print "<font size=+1><b>$n.</b></font>\n";
	    }
	    print "<a href=$cgibinurl/tunewhack.cgi?$i><img src=$topurl/skull.gif border=0 alt=\"Whack\"></a></td>\n";
	    print "<td width=60%><font size=+1><b>$title</b></font>\n";
	    if ($trks eq "") {
		if ($trk ne "") {
		    print "<br>&nbsp; <em>(playing track $trk)</em>";
		}
	    } else {
		print "<br>&nbsp; <em>";
		foreach $j (sort numeric (split /,/, $trks)) {
		    if ($j >= $trk) {
			if ($j == $trk) {
			    print " <b><u>$j</u></b>";
			} else {
			    print " <b> $j </b>";
			}
		    } else {
			print " $j";
		    }
		}
		print "</em>";
	    }
	    print "</td>\n";
	    print "<td>($time) $host $reqtime $dedic</td>\n";
	    print "</tr>\n";
	} else {
	    $title = Tunebot::friendlyTrackTitle($path);
	    $time = gettime($path);
	    print "<tr><td width=10%>\n";
	    if ($random_from_q == 0) {
		print "$n.\n";
	    }
	    print "<a href=$cgibinurl/tunewhack.cgi?$i><img src=$topurl/skull.gif border=0 alt=\"Whack\"></a></td>\n";
	    print "<td width=60%>$title</td>\n";
	    print "<td><a href=\"$cgibinurl/abouttrack.cgi?$path\">$time</a> $host $reqtime $dedic</td>\n";
	    print "</tr>\n";
	}
	$n++;
    }
}

print "<tr><td colspan=3 align=center><font size=+1><b>Recent Tracks</b></font></td></tr>";

@paths = ();
open(I, "/usr/bin/tail -$how_many " . $q_directory . "/history" . "|");
while ($line = <I>) {
    chop $line;
    @lines = (@lines, $line);
}
foreach $line (reverse @lines) {
    @raw = split(" ", $line);
    $path = @raw[0];
    $title = Tunebot::friendlyTrackTitle($path, 1);
    $time = gettime($path);
    $pt = @raw[1];
    $playtime = substr($pt,0,4) . "/" . substr($pt,4,2) . "/" . substr($pt,6,2) . " " . substr($pt,8,2) . ":" . substr($pt,10,2);
    $playtime = "<em>~ " . nicetime($playtime) . "</em>";
    if ($line =~ /REQ/) {
	$req = " <img src=\"$topurl/request.gif\">";
	($host = $line) =~ s/.*HOSTNAME=([^ ]*).*/$1/;
	if (!($host =~ /^[0-9]/)) {
	    $hdomain = $host;
	    $hdomain =~ s/^[^.]*.//;
	    if ($hdomain eq $mydomain) {
		$host =~ s/\..*//;
	    }
	}
    } else {
	$req = "";
	$host = "";
    }
    print "<tr>\n";
    print "<td width=10%><a href=$cgibinurl/tunefeedback.cgi?UP=$path><img src=$topurl/thumbsup.gif border=0 alt=\"Thumbs-Up\"></a>\n";
    print "<a href=$cgibinurl/tunefeedback.cgi?DOWN=$path><img src=$topurl/thumbsdown.gif border=0 alt=\"Thumbs-Down\"></a></td>\n";
    print "<td width=60%>$title</td>\n";
    print "<td><a href=\"$cgibinurl/abouttrack.cgi?$path\">$time</a>$req $host $playtime</td>\n";
    print "</tr>\n";
}
close(I);

print "</table>\n";
print "<center>\n";
print "<a href=\"$cgibinurl/tuneq.cgi?" . $how_many * 2 . "\">show like more history</a>";
print "</center>\n";
print "<p>\n";
print "<center>\n";
print "<b>Legend...</b>\n";
print "<img src=$topurl/thumbsup.gif alt=\"Thumbs-Up\">\n";
print "Dank\n";
print "...\n";
print "<img src=$topurl/thumbsdown.gif alt=\"Thumbs-Down\">\n";
print "Schwag\n";
print "...\n";
print "<img src=$topurl/skull.gif alt=\"Whack\">\n";
print "I take it back\n";
print "...\n";
print "<img src=$topurl/request.gif alt=\"Request\">\n";
print "Was requested\n";
print "</center>\n";

Tunebot::printPageTrailer;
exit 0

